-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Scheduler - Context Menu
This demo shows how to create a context menu for appointments and cells using the onAppointmentContextMenu and onCellContextMenu functions.
Backend API
$(() => {
$('#scheduler').dxScheduler({
timeZone: 'America/Los_Angeles',
dataSource: data,
views: ['day', 'month'],
currentView: 'month',
currentDate: new Date(2020, 10, 25),
startDayHour: 9,
recurrenceEditMode: 'series',
groups: [],
onAppointmentContextMenu(e) {
const items = getAppointmentContextMenuItems(e);
contextMenuInstance.option('dataSource', items);
},
onCellContextMenu(e) {
const items = getCellContextMenuItems(e);
contextMenuInstance.option('dataSource', items);
},
resources: [{
fieldExpr: 'roomId',
dataSource: resourcesData,
label: 'Room',
icon: 'conferenceroomoutline',
}],
height: 730,
});
const contextMenuInstance = $('#context-menu').dxContextMenu({
width: 200,
dataSource: [],
target: '#scheduler',
itemTemplate: contextMenuItemTemplate,
onItemClick: (e) => {
e.itemData.onItemClick(e);
},
onHiding: (e) => {
e.component.option('dataSource', []);
},
}).dxContextMenu('instance');
function contextMenuItemTemplate(itemData) {
const template = $('<div></div>');
if (itemData.color) {
$('<div>')
.addClass('item-badge')
.css('background-color', itemData.color)
.appendTo(template);
}
template.append(itemData.text);
return template;
}
function getAppointmentContextMenuItems(e) {
const scheduler = e.component;
const { appointmentData: appointment, targetedAppointmentData: targetedAppointment } = e;
return [
{
text: 'Open',
onItemClick: () => { scheduler.showAppointmentPopup(appointment); },
},
{
text: 'Delete',
onItemClick: () => { scheduler.deleteAppointment(appointment); },
},
{
text: 'Repeat Weekly',
beginGroup: true,
onItemClick: () => {
scheduler.updateAppointment(appointment, $.extend(appointment, {
startDate: targetedAppointment.startDate,
recurrenceRule: 'FREQ=WEEKLY',
}));
},
},
{
text: 'Set Room',
beginGroup: true,
disabled: true,
},
...resourcesData.map((item) => ({
...item,
onItemClick: (clickEvent) => {
scheduler.updateAppointment(appointment, $.extend(appointment, {
roomId: [clickEvent.itemData.id],
}));
},
})),
];
}
function getCellContextMenuItems(e) {
const scheduler = e.component;
return [
{
text: 'New Appointment',
onItemClick: () => {
scheduler.showAppointmentPopup({
startDate: e.cellData.startDateUTC,
}, true);
},
},
{
text: 'New Recurring Appointment',
onItemClick: () => {
scheduler.showAppointmentPopup({
startDate: e.cellData.startDateUTC,
recurrenceRule: 'FREQ=DAILY',
}, true);
},
},
{
text: 'Group by Room/Ungroup',
beginGroup: true,
onItemClick: () => {
if (scheduler.option('groups').length) {
scheduler.option({ crossScrollingEnabled: false, groups: [] });
} else {
scheduler.option({ crossScrollingEnabled: true, groups: ['roomId'] });
}
},
},
{
text: 'Go to Today',
onItemClick: () => {
scheduler.option('currentDate', new Date());
},
},
];
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="data.js"></script>
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="scheduler"></div>
<div id="context-menu"></div>
</div>
</body>
</html>
.item-badge {
text-align: center;
float: left;
margin-right: 12px;
color: white;
width: 18px;
height: 18px;
font-size: 19.5px;
border-radius: 18px;
margin-top: 2px;
}
const data = [
{
text: 'Watercolor Landscape',
roomId: [1],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T19:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,TH;COUNT=10',
}, {
text: 'Oil Painting for Beginners',
roomId: [2],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T19:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=SU,WE;COUNT=10',
}, {
text: 'Testing',
roomId: [3],
startDate: new Date('2020-11-01T20:00:00.000Z'),
endDate: new Date('2020-11-01T21:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=SU;WKST=TU;INTERVAL=2;COUNT=2',
}, {
text: 'Meeting of Instructors',
roomId: [4],
startDate: new Date('2020-11-01T17:00:00.000Z'),
endDate: new Date('2020-11-01T17:15:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=TU;UNTIL=20201203',
}, {
text: 'Recruiting students',
roomId: [5],
startDate: new Date('2020-10-24T18:00:00.000Z'),
endDate: new Date('2020-10-24T19:00:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYWEEKNO=50;WKST=SU',
recurrenceException: '20201212T190000Z',
}, {
text: 'Final exams',
roomId: [3],
startDate: new Date('2020-10-24T20:00:00.000Z'),
endDate: new Date('2020-10-24T21:35:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYWEEKNO=51;BYDAY=WE,TH',
}, {
text: 'Monthly Planning',
roomId: [4],
startDate: new Date('2020-11-24T22:30:00.000Z'),
endDate: new Date('2020-11-24T23:45:00.000Z'),
recurrenceRule: 'FREQ=MONTHLY;BYMONTHDAY=28;COUNT=1',
}, {
text: 'Open Day',
roomId: [5],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T21:00:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYYEARDAY=333',
},
];
const resourcesData = [
{
text: 'Room 101',
id: 1,
color: '#1564C0',
}, {
text: 'Room 102',
id: 2,
color: '#C2185B',
}, {
text: 'Room 103',
id: 3,
color: '#7B1FA2',
}, {
text: 'Meeting room',
id: 4,
color: '#DD2C00',
}, {
text: 'Conference hall',
id: 5,
color: '#2E7D32',
},
];

Backend API
import React, { useCallback, useRef, useState } from 'react';
import { Scheduler, Resource } from 'devextreme-react/scheduler';
import type { SchedulerRef, SchedulerTypes } from 'devextreme-react/scheduler';
import { ContextMenu } from 'devextreme-react/context-menu';
import type { ContextMenuTypes } from 'devextreme-react/context-menu';
import ItemTemplate from './itemTemplate.tsx';
import { data, resourcesData } from './data.ts';
import type { ContextMenuItem } from './types';
const views: SchedulerTypes.ViewType[] = ['day', 'month'];
const onContextMenuItemClick = (e: ContextMenuTypes.ItemClickEvent<ContextMenuItem>) => {
e.itemData?.onItemClick?.(e);
};
const App = () => {
const schedulerRef = useRef<SchedulerRef>(null);
const [currentDate, setCurrentDate] = useState(new Date(2020, 10, 25));
const [contextMenuItems, setContextMenuItems] = useState<ContextMenuItem[]>([]);
const [groups, setGroups] = useState<string[]>([]);
const [crossScrollingEnabled, setCrossScrollingEnabled] = useState(false);
const getAppointmentContextMenuItems = useCallback((e: SchedulerTypes.AppointmentContextMenuEvent) => {
const { appointmentData: appointment, targetedAppointmentData: targetedAppointment } = e;
const scheduler = e.component;
return [
{
text: 'Open',
onItemClick: () => scheduler?.showAppointmentPopup(appointment),
},
{
text: 'Delete',
onItemClick: () => scheduler?.deleteAppointment(appointment),
},
{
text: 'Repeat Weekly',
beginGroup: true,
onItemClick: () => scheduler?.updateAppointment(appointment, {
...appointment,
startDate: targetedAppointment?.startDate,
recurrenceRule: 'FREQ=WEEKLY',
}),
},
{
text: 'Set Room',
beginGroup: true,
disabled: true,
},
...resourcesData.map((item) => ({
...item,
onItemClick: (clickEvent: ContextMenuTypes.ItemClickEvent<ContextMenuItem>) => {
scheduler?.updateAppointment(appointment, {
...appointment,
roomId: [clickEvent.itemData?.id],
});
},
})),
];
}, []);
const getCellContextMenuItems = useCallback((e: SchedulerTypes.CellContextMenuEvent) => {
const scheduler = e.component;
return [
{
text: 'New Appointment',
onItemClick: () => {
scheduler?.showAppointmentPopup(
{ startDate: e.cellData.startDateUTC },
true,
);
},
},
{
text: 'New Recurring Appointment',
onItemClick: () => {
scheduler?.showAppointmentPopup(
{
startDate: e.cellData.startDateUTC,
recurrenceRule: 'FREQ=DAILY',
},
true,
);
},
},
{
text: 'Group by Room/Ungroup',
beginGroup: true,
onItemClick: () => {
if (groups.length) {
setCrossScrollingEnabled(false);
setGroups([]);
} else {
setCrossScrollingEnabled(true);
setGroups(['roomId']);
}
},
},
{
text: 'Go to Today',
onItemClick: () => {
setCurrentDate(new Date());
},
},
];
}, [groups]);
const onAppointmentContextMenu = useCallback((e: SchedulerTypes.AppointmentContextMenuEvent) => {
const items = getAppointmentContextMenuItems(e);
setContextMenuItems(items);
}, [getAppointmentContextMenuItems]);
const onCellContextMenu = useCallback((e: SchedulerTypes.CellContextMenuEvent) => {
const items = getCellContextMenuItems(e);
setContextMenuItems(items);
}, [getCellContextMenuItems]);
const onContextMenuHiding = useCallback(() => {
setContextMenuItems([]);
}, []);
return (
<>
<Scheduler
ref={schedulerRef}
timeZone="America/Los_Angeles"
dataSource={data}
views={views}
groups={groups}
crossScrollingEnabled={crossScrollingEnabled}
defaultCurrentView="month"
currentDate={currentDate}
startDayHour={9}
recurrenceEditMode="series"
onAppointmentContextMenu={onAppointmentContextMenu}
onCellContextMenu={onCellContextMenu}
height={730}
>
<Resource
dataSource={resourcesData}
fieldExpr="roomId"
label="Room"
icon="conferenceroomoutline"
/>
</Scheduler>
<ContextMenu
dataSource={contextMenuItems}
width={200}
target='.dx-scheduler'
onItemClick={onContextMenuItemClick}
onHiding={onContextMenuHiding}
itemComponent={ItemTemplate}
/>
</>
);
};
export default App;
import React, { useCallback, useRef, useState } from 'react';
import { Scheduler, Resource } from 'devextreme-react/scheduler';
import { ContextMenu } from 'devextreme-react/context-menu';
import ItemTemplate from './itemTemplate.js';
import { data, resourcesData } from './data.js';
const views = ['day', 'month'];
const onContextMenuItemClick = (e) => {
e.itemData?.onItemClick?.(e);
};
const App = () => {
const schedulerRef = useRef(null);
const [currentDate, setCurrentDate] = useState(new Date(2020, 10, 25));
const [contextMenuItems, setContextMenuItems] = useState([]);
const [groups, setGroups] = useState([]);
const [crossScrollingEnabled, setCrossScrollingEnabled] = useState(false);
const getAppointmentContextMenuItems = useCallback((e) => {
const { appointmentData: appointment, targetedAppointmentData: targetedAppointment } = e;
const scheduler = e.component;
return [
{
text: 'Open',
onItemClick: () => scheduler?.showAppointmentPopup(appointment),
},
{
text: 'Delete',
onItemClick: () => scheduler?.deleteAppointment(appointment),
},
{
text: 'Repeat Weekly',
beginGroup: true,
onItemClick: () =>
scheduler?.updateAppointment(appointment, {
...appointment,
startDate: targetedAppointment?.startDate,
recurrenceRule: 'FREQ=WEEKLY',
}),
},
{
text: 'Set Room',
beginGroup: true,
disabled: true,
},
...resourcesData.map((item) => ({
...item,
onItemClick: (clickEvent) => {
scheduler?.updateAppointment(appointment, {
...appointment,
roomId: [clickEvent.itemData?.id],
});
},
})),
];
}, []);
const getCellContextMenuItems = useCallback(
(e) => {
const scheduler = e.component;
return [
{
text: 'New Appointment',
onItemClick: () => {
scheduler?.showAppointmentPopup({ startDate: e.cellData.startDateUTC }, true);
},
},
{
text: 'New Recurring Appointment',
onItemClick: () => {
scheduler?.showAppointmentPopup(
{
startDate: e.cellData.startDateUTC,
recurrenceRule: 'FREQ=DAILY',
},
true,
);
},
},
{
text: 'Group by Room/Ungroup',
beginGroup: true,
onItemClick: () => {
if (groups.length) {
setCrossScrollingEnabled(false);
setGroups([]);
} else {
setCrossScrollingEnabled(true);
setGroups(['roomId']);
}
},
},
{
text: 'Go to Today',
onItemClick: () => {
setCurrentDate(new Date());
},
},
];
},
[groups],
);
const onAppointmentContextMenu = useCallback(
(e) => {
const items = getAppointmentContextMenuItems(e);
setContextMenuItems(items);
},
[getAppointmentContextMenuItems],
);
const onCellContextMenu = useCallback(
(e) => {
const items = getCellContextMenuItems(e);
setContextMenuItems(items);
},
[getCellContextMenuItems],
);
const onContextMenuHiding = useCallback(() => {
setContextMenuItems([]);
}, []);
return (
<>
<Scheduler
ref={schedulerRef}
timeZone="America/Los_Angeles"
dataSource={data}
views={views}
groups={groups}
crossScrollingEnabled={crossScrollingEnabled}
defaultCurrentView="month"
currentDate={currentDate}
startDayHour={9}
recurrenceEditMode="series"
onAppointmentContextMenu={onAppointmentContextMenu}
onCellContextMenu={onCellContextMenu}
height={730}
>
<Resource
dataSource={resourcesData}
fieldExpr="roomId"
label="Room"
icon="conferenceroomoutline"
/>
</Scheduler>
<ContextMenu
dataSource={contextMenuItems}
width={200}
target=".dx-scheduler"
onItemClick={onContextMenuItemClick}
onHiding={onContextMenuHiding}
itemComponent={ItemTemplate}
/>
</>
);
};
export default App;
import React from 'react';
type ItemTemplateProps = {
data: {
color: string;
text: string;
}
};
const ItemTemplate = (props: ItemTemplateProps) => (
<div>
{props.data.color && <div className="item-badge" style={{ backgroundColor: props.data.color }} />}
{props.data.text}
</div>
);
export default ItemTemplate;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { Appointment, Resource } from './types';
export const data: Appointment[] = [
{
text: 'Watercolor Landscape',
roomId: [1],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T19:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,TH;COUNT=10',
}, {
text: 'Oil Painting for Beginners',
roomId: [2],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T19:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=SU,WE;COUNT=10',
}, {
text: 'Testing',
roomId: [3],
startDate: new Date('2020-11-01T20:00:00.000Z'),
endDate: new Date('2020-11-01T21:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=SU;WKST=TU;INTERVAL=2;COUNT=2',
}, {
text: 'Meeting of Instructors',
roomId: [4],
startDate: new Date('2020-11-01T17:00:00.000Z'),
endDate: new Date('2020-11-01T17:15:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=TU;UNTIL=20201203',
}, {
text: 'Recruiting students',
roomId: [5],
startDate: new Date('2020-10-24T18:00:00.000Z'),
endDate: new Date('2020-10-24T19:00:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYWEEKNO=50;WKST=SU',
recurrenceException: '20201212T190000Z',
}, {
text: 'Final exams',
roomId: [3],
startDate: new Date('2020-10-24T20:00:00.000Z'),
endDate: new Date('2020-10-24T21:35:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYWEEKNO=51;BYDAY=WE,TH',
}, {
text: 'Monthly Planning',
roomId: [4],
startDate: new Date('2020-11-24T22:30:00.000Z'),
endDate: new Date('2020-11-24T23:45:00.000Z'),
recurrenceRule: 'FREQ=MONTHLY;BYMONTHDAY=28;COUNT=1',
}, {
text: 'Open Day',
roomId: [5],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T21:00:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYYEARDAY=333',
},
];
export const resourcesData: Resource[] = [
{
text: 'Room 101',
id: 1,
color: '#1564C0',
}, {
text: 'Room 102',
id: 2,
color: '#C2185B',
}, {
text: 'Room 103',
id: 3,
color: '#7B1FA2',
}, {
text: 'Meeting room',
id: 4,
color: '#DD2C00',
}, {
text: 'Conference hall',
id: 5,
color: '#2E7D32',
},
];
import type { SchedulerTypes } from 'devextreme-react/scheduler';
import type { ContextMenuTypes } from 'devextreme-react/context-menu';
export type Appointment = SchedulerTypes.Appointment & { roomId: number[] };
export type Resource = {
id?: number;
text: string;
color?: string;
};
export type ContextMenuItem = ContextMenuTypes.Item & Partial<Resource> & { onItemClick?: (e: ContextMenuTypes.ItemClickEvent<ContextMenuItem>) => void };
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
const ItemTemplate = (props) => (
<div>
{props.data.color && (
<div
className="item-badge"
style={{ backgroundColor: props.data.color }}
/>
)}
{props.data.text}
</div>
);
export default ItemTemplate;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const data = [
{
text: 'Watercolor Landscape',
roomId: [1],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T19:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,TH;COUNT=10',
},
{
text: 'Oil Painting for Beginners',
roomId: [2],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T19:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=SU,WE;COUNT=10',
},
{
text: 'Testing',
roomId: [3],
startDate: new Date('2020-11-01T20:00:00.000Z'),
endDate: new Date('2020-11-01T21:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=SU;WKST=TU;INTERVAL=2;COUNT=2',
},
{
text: 'Meeting of Instructors',
roomId: [4],
startDate: new Date('2020-11-01T17:00:00.000Z'),
endDate: new Date('2020-11-01T17:15:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=TU;UNTIL=20201203',
},
{
text: 'Recruiting students',
roomId: [5],
startDate: new Date('2020-10-24T18:00:00.000Z'),
endDate: new Date('2020-10-24T19:00:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYWEEKNO=50;WKST=SU',
recurrenceException: '20201212T190000Z',
},
{
text: 'Final exams',
roomId: [3],
startDate: new Date('2020-10-24T20:00:00.000Z'),
endDate: new Date('2020-10-24T21:35:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYWEEKNO=51;BYDAY=WE,TH',
},
{
text: 'Monthly Planning',
roomId: [4],
startDate: new Date('2020-11-24T22:30:00.000Z'),
endDate: new Date('2020-11-24T23:45:00.000Z'),
recurrenceRule: 'FREQ=MONTHLY;BYMONTHDAY=28;COUNT=1',
},
{
text: 'Open Day',
roomId: [5],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T21:00:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYYEARDAY=333',
},
];
export const resourcesData = [
{
text: 'Room 101',
id: 1,
color: '#1564C0',
},
{
text: 'Room 102',
id: 2,
color: '#C2185B',
},
{
text: 'Room 103',
id: 3,
color: '#7B1FA2',
},
{
text: 'Meeting room',
id: 4,
color: '#DD2C00',
},
{
text: 'Conference hall',
id: 5,
color: '#2E7D32',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.item-badge {
text-align: center;
float: left;
margin-right: 12px;
color: white;
width: 18px;
height: 18px;
font-size: 19.5px;
border-radius: 18px;
margin-top: 2px;
}

Backend API
<template>
<div>
<DxScheduler
time-zone="America/Los_Angeles"
:groups="groups"
:data-source="dataSource"
:views="views"
:current-date="currentDate"
:cross-scrolling-enabled="crossScrollingEnabled"
:start-day-hour="9"
:height="730"
:on-appointment-context-menu="onAppointmentContextMenu"
:on-cell-context-menu="onCellContextMenu"
current-view="month"
recurrence-edit-mode="series"
>
<DxResource
:data-source="resourcesData"
field-expr="roomId"
label="Room"
icon="conferenceroomoutline"
/>
</DxScheduler>
<DxContextMenu
:data-source="contextMenuItems"
:width="200"
target=".dx-scheduler"
:on-item-click="onContextMenuItemClick"
:on-hiding="onContextMenuHiding"
item-template="itemTemplateSlot"
>
<template #itemTemplateSlot="{ data: itemData }">
<ItemTemplate :item-data="itemData"/>
</template>
</DxContextMenu>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import { DxScheduler, DxResource, type DxSchedulerTypes } from 'devextreme-vue/scheduler';
import { DxContextMenu, type DxContextMenuTypes } from 'devextreme-vue/context-menu';
import ItemTemplate from './ItemTemplate.vue';
import { resourcesData, data } from './data.ts';
import type { ContextMenuItem } from './types';
const views = ['day', 'month'];
const currentDate = ref(new Date(2020, 10, 25));
const dataSource = data;
const groups = ref<string[]>([]);
const crossScrollingEnabled = ref(false);
const contextMenuItems = ref<ContextMenuItem[]>([]);
const onAppointmentContextMenu = (e: DxSchedulerTypes.AppointmentContextMenuEvent) => {
const items = getAppointmentContextMenuItems(e);
contextMenuItems.value = items;
};
const onCellContextMenu = (e: DxSchedulerTypes.CellContextMenuEvent) => {
const items = getCellContextMenuItems(e);
contextMenuItems.value = items;
};
const onContextMenuItemClick = (e: DxContextMenuTypes.ItemClickEvent<ContextMenuItem>) => {
e.itemData?.onItemClick?.(e);
};
const onContextMenuHiding = () => {
contextMenuItems.value = [];
};
const getAppointmentContextMenuItems = (
e: DxSchedulerTypes.AppointmentContextMenuEvent,
): ContextMenuItem[] => {
const scheduler = e.component;
const { appointmentData: appointment, targetedAppointmentData: targetedAppointment } = e;
return [
{
text: 'Open',
onItemClick: () => { scheduler.showAppointmentPopup(appointment); },
},
{
text: 'Delete',
onItemClick: () => { scheduler.deleteAppointment(appointment); },
},
{
text: 'Repeat Weekly',
beginGroup: true,
onItemClick: () => {
scheduler.updateAppointment(appointment, {
...appointment,
startDate: targetedAppointment?.startDate,
recurrenceRule: 'FREQ=WEEKLY',
});
},
},
{
text: 'Set Room',
beginGroup: true,
disabled: true,
},
...resourcesData.map((item) => ({
...item,
onItemClick: (clickEvent: DxContextMenuTypes.ItemClickEvent<ContextMenuItem>) => {
scheduler.updateAppointment(appointment, {
...appointment,
roomId: [clickEvent.itemData?.id],
});
},
})),
];
};
const getCellContextMenuItems = (
e: DxSchedulerTypes.CellContextMenuEvent,
): ContextMenuItem[] => {
const scheduler = e.component;
return [
{
text: 'New Appointment',
onItemClick: () => {
scheduler.showAppointmentPopup({
startDate: e.cellData.startDateUTC,
}, true);
},
},
{
text: 'New Recurring Appointment',
onItemClick: () => {
scheduler.showAppointmentPopup({
startDate: e.cellData.startDateUTC,
recurrenceRule: 'FREQ=DAILY',
}, true);
},
},
{
text: 'Group by Room/Ungroup',
beginGroup: true,
onItemClick: () => {
if (groups.value.length) {
groups.value = [];
crossScrollingEnabled.value = false;
} else {
groups.value = ['roomId'];
crossScrollingEnabled.value = true;
}
},
},
{
text: 'Go to Today',
onItemClick: () => {
currentDate.value = new Date();
},
},
];
};
</script>
<template>
<div>
<div>
<div
v-if="itemData.color"
:style="styleObject"
class="item-badge"
/>
{{ itemData.text }}
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
const props = withDefaults(defineProps<{
itemData?: any
}>(), {
itemData: () => {},
});
const styleObject = ref({ backgroundColor: props.itemData.color });
</script>
<style scoped>
.item-badge {
text-align: center;
float: left;
margin-right: 12px;
color: white;
width: 18px;
height: 18px;
font-size: 19.5px;
border-radius: 18px;
margin-top: 2px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const data = [
{
text: 'Watercolor Landscape',
roomId: [1],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T19:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,TH;COUNT=10',
}, {
text: 'Oil Painting for Beginners',
roomId: [2],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T19:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=SU,WE;COUNT=10',
}, {
text: 'Testing',
roomId: [3],
startDate: new Date('2020-11-01T20:00:00.000Z'),
endDate: new Date('2020-11-01T21:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=SU;WKST=TU;INTERVAL=2;COUNT=2',
}, {
text: 'Meeting of Instructors',
roomId: [4],
startDate: new Date('2020-11-01T17:00:00.000Z'),
endDate: new Date('2020-11-01T17:15:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=TU;UNTIL=20201203',
}, {
text: 'Recruiting students',
roomId: [5],
startDate: new Date('2020-10-24T18:00:00.000Z'),
endDate: new Date('2020-10-24T19:00:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYWEEKNO=50;WKST=SU',
recurrenceException: '20201212T190000Z',
}, {
text: 'Final exams',
roomId: [3],
startDate: new Date('2020-10-24T20:00:00.000Z'),
endDate: new Date('2020-10-24T21:35:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYWEEKNO=51;BYDAY=WE,TH',
}, {
text: 'Monthly Planning',
roomId: [4],
startDate: new Date('2020-11-24T22:30:00.000Z'),
endDate: new Date('2020-11-24T23:45:00.000Z'),
recurrenceRule: 'FREQ=MONTHLY;BYMONTHDAY=28;COUNT=1',
}, {
text: 'Open Day',
roomId: [5],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T21:00:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYYEARDAY=333',
},
];
export const resourcesData = [
{
text: 'Room 101',
id: 1,
color: '#1564C0',
}, {
text: 'Room 102',
id: 2,
color: '#C2185B',
}, {
text: 'Room 103',
id: 3,
color: '#7B1FA2',
}, {
text: 'Meeting room',
id: 4,
color: '#DD2C00',
}, {
text: 'Conference hall',
id: 5,
color: '#2E7D32',
},
];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
import type { DxContextMenuTypes } from 'devextreme-vue/context-menu';
interface ResourceItem {
text: string;
id: number;
color: string;
}
export type ContextMenuItem = DxContextMenuTypes.Item & Partial<ResourceItem> & {
onItemClick?: (e: DxContextMenuTypes.ItemClickEvent<ContextMenuItem>) => void
};
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

Backend API
<dx-scheduler
timeZone="America/Los_Angeles"
[crossScrollingEnabled]="crossScrollingEnabled"
[dataSource]="appointmentsData"
[views]="['day', 'month']"
currentView="month"
[groups]="groups"
recurrenceEditMode="series"
[currentDate]="currentDate"
(onCellContextMenu)="onCellContextMenu($event)"
(onAppointmentContextMenu)="onAppointmentContextMenu($event)"
[startDayHour]="9"
[height]="730"
>
<dxi-scheduler-resource
fieldExpr="roomId"
label="room"
[dataSource]="resourcesData"
icon="conferenceroomoutline"
></dxi-scheduler-resource>
</dx-scheduler>
<dx-context-menu
[items]="contextMenuItems"
target=".dx-scheduler"
(onItemClick)="onContextMenuItemClick($event)"
(onHiding)="onContextMenuHiding()"
[width]="200"
>
<div *dxTemplate="let e of 'item'">
<div>
@if(e.color) {
<div class="item-badge" [style.background-color]="e.color"></div>
}
{{ e.text }}
</div>
</div>
</dx-context-menu>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, ViewChild, provideZoneChangeDetection } from '@angular/core';
import {
DxSchedulerModule,
DxSchedulerComponent,
type DxSchedulerTypes,
} from 'devextreme-angular/ui/scheduler';
import { DxContextMenuModule, type DxContextMenuTypes } from 'devextreme-angular/ui/context-menu';
import { Service, type Appointment, type Resource, type ContextMenuItem } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxSchedulerModule,
DxContextMenuModule,
],
})
export class AppComponent {
@ViewChild(DxSchedulerComponent, { static: false }) scheduler!: DxSchedulerComponent;
appointmentsData!: Appointment[];
currentDate: Date = new Date(2020, 10, 25);
resourcesData: Resource[];
groups: string[] = [];
crossScrollingEnabled = false;
contextMenuItems: ContextMenuItem[] = [];
constructor(service: Service) {
this.resourcesData = service.getResources();
this.appointmentsData = service.getAppointments();
}
onContextMenuItemClick(e: DxContextMenuTypes.ItemClickEvent<ContextMenuItem>) {
e.itemData.onItemClick(e);
}
onAppointmentContextMenu(e: DxSchedulerTypes.AppointmentContextMenuEvent) {
const items = this.getAppointmentContextMenuItems(e);
this.contextMenuItems = items;
}
onCellContextMenu(e: DxSchedulerTypes.CellContextMenuEvent) {
const items = this.getCellContextMenuItems(e);
this.contextMenuItems = items;
}
onContextMenuHiding() {
this.contextMenuItems = [];
}
getAppointmentContextMenuItems(e: DxSchedulerTypes.AppointmentContextMenuEvent): ContextMenuItem[] {
const {
appointmentData: appointment,
targetedAppointmentData: targetedAppointment,
} = e;
const scheduler = this.scheduler.instance;
return [
{
text: 'Open',
onItemClick: () => scheduler.showAppointmentPopup(appointment),
},
{
text: 'Delete',
onItemClick: () => scheduler.deleteAppointment(appointment),
},
{
text: 'Repeat Weekly',
beginGroup: true,
onItemClick: () => scheduler.updateAppointment(appointment, {
...appointment,
startDate: targetedAppointment.startDate,
recurrenceRule: 'FREQ=WEEKLY',
}),
},
{
text: 'Set Room',
beginGroup: true,
disabled: true,
},
...this.resourcesData.map((item) => ({
...item,
onItemClick: ({ itemData }: DxContextMenuTypes.ItemClickEvent<Resource>) => scheduler.updateAppointment(appointment, {
...appointment,
roomId: [itemData.id],
}),
})),
];
}
getCellContextMenuItems(e: DxSchedulerTypes.CellContextMenuEvent): ContextMenuItem[] {
const { cellData } = e;
const scheduler = this.scheduler.instance;
return [
{
text: 'New Appointment',
onItemClick: () => scheduler.showAppointmentPopup(
{ startDate: cellData.startDateUTC },
true,
),
},
{
text: 'New Recurring Appointment',
onItemClick: () => scheduler.showAppointmentPopup(
{
startDate: cellData.startDateUTC,
recurrenceRule: 'FREQ=DAILY',
},
true,
),
},
{
text: 'Group by Room/Ungroup',
beginGroup: true,
onItemClick: () => {
if (this.groups.length) {
this.crossScrollingEnabled = false;
this.groups = [];
} else {
this.crossScrollingEnabled = true;
this.groups = ['roomId'];
}
},
},
{
text: 'Go to Today',
onItemClick: () => {
this.currentDate = new Date();
},
},
];
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .item-badge {
text-align: center;
float: left;
margin-right: 12px;
color: white;
width: 18px;
height: 18px;
font-size: 19.5px;
border-radius: 18px;
margin-top: 2px;
}
import { Injectable } from '@angular/core';
import type { DxContextMenuTypes } from 'devextreme-angular/ui/context-menu';
export interface Appointment {
text: string;
roomId: number[];
startDate: Date;
endDate: Date;
recurrenceRule?: string;
recurrenceException?: string;
}
export interface Resource {
text: string;
id: number;
color: string;
}
export type ContextMenuItem = DxContextMenuTypes.Item & Partial<Resource> & {
onItemClick?: (e: DxContextMenuTypes.ItemClickEvent<ContextMenuItem>) => void
};
const appointments: Appointment[] = [
{
text: 'Watercolor Landscape',
roomId: [1],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T19:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=MO,TH;COUNT=10',
}, {
text: 'Oil Painting for Beginners',
roomId: [2],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T19:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=SU,WE;COUNT=10',
}, {
text: 'Testing',
roomId: [3],
startDate: new Date('2020-11-01T20:00:00.000Z'),
endDate: new Date('2020-11-01T21:00:00.000Z'),
recurrenceRule: 'FREQ=WEEKLY;BYDAY=SU;WKST=TU;INTERVAL=2;COUNT=2',
}, {
text: 'Meeting of Instructors',
roomId: [4],
startDate: new Date('2020-11-01T17:00:00.000Z'),
endDate: new Date('2020-11-01T17:15:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=TU;UNTIL=20201203',
}, {
text: 'Recruiting students',
roomId: [5],
startDate: new Date('2020-10-24T18:00:00.000Z'),
endDate: new Date('2020-10-24T19:00:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYWEEKNO=50;WKST=SU',
recurrenceException: '20201212T190000Z',
}, {
text: 'Final exams',
roomId: [3],
startDate: new Date('2020-10-24T20:00:00.000Z'),
endDate: new Date('2020-10-24T21:35:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYWEEKNO=51;BYDAY=WE,TH',
}, {
text: 'Monthly Planning',
roomId: [4],
startDate: new Date('2020-11-24T22:30:00.000Z'),
endDate: new Date('2020-11-24T23:45:00.000Z'),
recurrenceRule: 'FREQ=MONTHLY;BYMONTHDAY=28;COUNT=1',
}, {
text: 'Open Day',
roomId: [5],
startDate: new Date('2020-11-01T17:30:00.000Z'),
endDate: new Date('2020-11-01T21:00:00.000Z'),
recurrenceRule: 'FREQ=YEARLY;BYYEARDAY=333',
},
];
const resources: Resource[] = [
{
text: 'Room 101',
id: 1,
color: '#1564C0',
}, {
text: 'Room 102',
id: 2,
color: '#C2185B',
}, {
text: 'Room 103',
id: 3,
color: '#7B1FA2',
}, {
text: 'Meeting room',
id: 4,
color: '#DD2C00',
}, {
text: 'Conference hall',
id: 5,
color: '#2E7D32',
},
];
@Injectable()
export class Service {
getAppointments(): Appointment[] {
return appointments;
}
getResources(): Resource[] {
return resources;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>